#define _GNU_SOURCE
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
//#include <unistd.h>
//#include <pthread.h>

#include "monitor.h"
#include "so.h"
#include "compat.h"

struct mon_screensaver_entry {
   unsigned int *(WINAPI *callback)(void *);
   void *args;
   int flags;
   struct mon_screensaver_entry *next;
   struct mon_screensaver_entry *prev;
};

static unsigned int * WINAPI mon_screensaver_run(void *args);
static void mon_screensaver_dump(void);

static thread_t t;
static mutex_t m = PTHREAD_MUTEX_INITIALIZER;
static struct mon_screensaver_entry *list = NULL;
static int running = 0;

static unsigned int * WINAPI mon_screensaver_run(void *args)
{
	/*
   struct mon_screensaver_entry *p, *e;
   int active;
   thread_t ct;
   FILE *pp = NULL;
   char buf[64];

   while(1) {
      MUTEX_LOCK(m);

      if(!list) {
         running = 0;
         MUTEX_UNLOCK(m);
         return NULL;
      }

      // TODO XXX riscrivere con i segnali dbus e la libreria 
      do {
         active = -1;
         if(!(pp = popen(SO"dbus-send --dest=org.gnome.ScreenSaver --print-reply /org/gnome/ScreenSaver org.gnome.ScreenSaver.GetActive", "r"))) break;
         while(fgets(buf, sizeof(buf), pp)) {
            if(strstr(buf, SO"boolean true")) {
               active = 1;
               break;
            } else if(strstr(buf, SO"boolean false")) {
               active = 0;
               break;
            }
         }
      } while(0);
      if(pp) { pclose(pp); pp = NULL; }
 
      do {
         if(active != -1) break;
         if(!(pp = popen(SO"dbus-send --dest=org.freedesktop.ScreenSaver --print-reply /ScreenSaver org.freedesktop.ScreenSaver.GetActive", "r"))) break;
         while(fgets(buf, sizeof(buf), pp)) {
            if(strstr(buf, SO"boolean true")) {
               active = 1;
               break;
            } else if(strstr(buf, SO"boolean false")) {
               active = 0;
               break;
            }
         }
      } while(0);
      if(pp) { pclose(pp); pp = NULL; }

      if(active != -1) {
         p = list;
         while(p) {
            if((!(p->flags & MON_FLAG_NEG) && active) || ((p->flags & MON_FLAG_NEG) && !active)) {
			   THREAD_CREATE(ct, p->callback, p->args);
			   THREAD_DETACH(ct);
               if(p == list) list = p->next;
               if(p->next) p->next->prev = p->prev;
               if(p->prev) p->prev->next = p->next;
               e = p;
               p = p->next;
               free(e);
            } else {
               p = p->next;
            }
         }
      }

      mon_screensaver_dump();

      MUTEX_UNLOCK(m);

      sleep(1);
   }
*/
}

void mon_screensaver_start(void *args) {
   MUTEX_LOCK(m);
   if (!running) if (!THREAD_CREATE(t, mon_screensaver_run, NULL)) running = 1;
   MUTEX_UNLOCK(m);
}

void *mon_screensaver_addwatch(unsigned int *(WINAPI *callback)(void *), void *args, int flags, ...)
{
   struct mon_screensaver_entry *p = NULL;

   MUTEX_LOCK(m);

   do {
      if(!list) {
         if(!(list = malloc(sizeof(struct mon_screensaver_entry)))) break;
         list->prev = NULL;
         p = list;
      } else {
         for(p = list; p->next; p = p->next);
         if(!(p->next = malloc(sizeof(struct mon_screensaver_entry)))) break;
         p->next->prev = p;
         p = p->next;
      }
      p->next = NULL;
      p->callback = callback;
      p->args = args;
      p->flags = flags;

      if(!running) if(!THREAD_CREATE(t, mon_screensaver_run, NULL)) running = 1;
   } while(0);

   mon_screensaver_dump();

   MUTEX_UNLOCK(m);

   return p;
}

void mon_screensaver_delwatch(void *entry)
{
   struct mon_screensaver_entry *p = NULL, *e = (struct mon_screensaver_entry *)entry;

   if(!list || !e) return;

   MUTEX_LOCK(m);

   for(p = list; p && (p != e); p = p->next);
   if(p) {
      if(p == list) list = p->next;
      if(p->next) p->next->prev = p->prev;
      if(p->prev) p->prev->next = p->next;
      free(p);
   }

   MUTEX_UNLOCK(m);

   return;
}

void mon_screensaver_dump(void)
{
#if 0
   struct mon_screensaver_entry *p = NULL;

   debugme("\n--- SCREENSAVER MONITOR LIST ---\n");
   for(p = list; p; p = p->next) debugme("- (at %p)\n", (void *)p);
   debugme("\n");
#endif

   return;
}
