#include "util_process.h"
#include <appmodel.h>


//get info about a process
int GetProcInfoW(DWORD dwPid, PROC_TYPE *pProcType, LPWSTR *pwszProc)
{
	//open the process
	HANDLE hProcess = OpenProcess(PROCESS_QUERY_LIMITED_INFORMATION, FALSE, dwPid);
	if (hProcess == NULL)
	{		
		return 0;
	}
	
	PROC_TYPE ProcType;

	WCHAR pwszMsg[256];
	DWORD dwRet = 0;

	UINT32 uiLen = 0;
	LONG rc = 0;

	if ((rc = GetApplicationUserModelId(hProcess, &uiLen, NULL)) != ERROR_INSUFFICIENT_BUFFER)
	{
		if (rc == APPMODEL_ERROR_NO_APPLICATION)
		{
			//it's a desktop application
			DWORD dwSize = MAX_PATH;
			if ((*pwszProc = (LPWSTR)malloc(dwSize * sizeof(WCHAR))) == NULL)
			{
				CloseHandle(hProcess);
				return 0;
			}

			//get the process name
			if (!QueryFullProcessImageName(hProcess, 0, *pwszProc, &dwSize))
			{
				CloseHandle(hProcess);
				return 0;
			}


			*pProcType = PROC_DESKTOP;

			return 1;
		}
		else
		{
			#ifdef _DEBUG
						//swprintf_s(pwszMsg, L"GetApplicationUserModelId failed with error %d\n", rc);
						//OutputDebugString(pwszMsg);
			#endif

			CloseHandle(hProcess);
			return 0;
		}
	}

	*pwszProc = (PWSTR)malloc(uiLen * sizeof(WCHAR));
	if (*pwszProc == NULL)
	{
		#ifdef _DEBUG
				OutputDebugString(L"Memory allocation failed\n");
		#endif

		CloseHandle(hProcess);
		return 0;
	}

	if ((rc = GetApplicationUserModelId(hProcess, &uiLen, *pwszProc)) != ERROR_SUCCESS)
	{
		#ifdef _DEBUG
				swprintf_s(pwszMsg, TEXT("GetApplicationUserModelId failed with error %d\n"), rc);
				OutputDebugString(pwszMsg);
		#endif
	}
	else
	{
		//it's a store app 
		#ifdef _DEBUG
				swprintf_s(pwszMsg, L"%s\n", *pwszProc);
				OutputDebugString(pwszMsg);
		#endif

		//wprintf_s(L"Process %u \n", dwPid);
		//ApplicationUserModelIdToElements(*pwszProc);

		*pProcType = PROC_APP;
	}

	//close the proc's handle
	CloseHandle(hProcess);

	return 1;
}